<script>
	import Chart from 'svelte-frappe-charts';
	import { only, pluck } from '$lib/array';
	import { dateFromParts } from '$lib/date';
	import { dashboardStation } from '$lib/preferences';
	import {
		minMaxTemperatures,
		periodSelector,
		periodKeys,
		periodConfig
	} from '$lib/Widgets/stores';

	let url;

	const fetchData = (period) => {
		fetch(`${url}?period=${period}`)
			.then(async (req) => await req.json())
			.then((data) => {
				minMaxTemperatures.set({
					period,
					data: {
						labels: only(data, $periodKeys).map((label) => dateFromParts(label, $periodConfig)),
						datasets: [
							{ values: pluck(data, 'tn'), name: 'Minimales' },
							{
								values: pluck(data, 'tx'),
								name: 'Maximales'
							}
						]
					}
				});
			});
	};

	$: {
		url = `https://api.infoclimat.localhost/api/station/${$dashboardStation.id}/temperatures`;
		fetchData($periodSelector);
	}
</script>

<div class="card col-span-4 xl:col-span-2 min-h-[4rem]">
	{#if $minMaxTemperatures.data.datasets.length > 0}
		<Chart
			data={$minMaxTemperatures.data}
			type="line"
			title="Évolution des températures maximales et minimales"
			axisOptions={{ xIsSeries: 1, xAxisMode: 'tick' }}
			lineOptions={{
				hideDots: true,
				line: true
			}}
			tooltipOptions={{
				formatTooltipY: (d) => parseFloat(d).toFixed(2) + ' °C'
			}}
		/>
	{/if}
</div>

<style lang="postcss">
	.card {
		@apply bg-white shadow p-3 rounded-md transition-shadow duration-200 ease-out;
	}
</style>
